package
{
	import aw.orx.controllers.commands.*;
	import aw.orx.controllers.events.*;
	import aw.orx.models.*;
	import aw.orx.models.services.*;
	import aw.orx.views.components.workArea.displayArea.EditionView;
	import aw.orx.views.components.workArea.displayArea.edition.ScreenView;
	import aw.orx.views.components.workArea.displayArea.edition.screen.PipAreaView;
	import aw.orx.views.components.workArea.displayArea.edition.screen.pipArea.pip.PipView;
	import aw.orx.views.mediators.workArea.displayArea.EditionMediator;
	import aw.orx.views.mediators.workArea.displayArea.edition.ScreenMediator;
	import aw.orx.views.mediators.workArea.displayArea.edition.screen.PipAreaMediator;
	import aw.orx.views.mediators.workArea.displayArea.edition.screen.pipArea.pip.PipMediator;
	
	import flash.display.DisplayObjectContainer;
	
	import org.robotlegs.mvcs.Context;

	public class MainContext extends Context
	{
		public function MainContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true)
		{
			super(contextView, autoStartup);
		}
		
		override public function startup():void
		{
			//Services
			injector.mapSingletonOf(IOrxService, LoaderOrxService);
			//var myClassInstance:XMLLoaderService = new XMLLoaderService();
			//injector.mapValue(XMLLoaderService, myClassInstance);
			injector.mapSingletonOf(ILoaderService, XMLLoaderService);
			
			//Models
			injector.mapSingleton(WorkAreaModel);
			injector.mapSingleton(DisplayAreaModel);
			injector.mapSingleton(EditionModel);
			injector.mapSingleton(InputModel);
			injector.mapSingleton(PipAreaModel);
			injector.mapSingleton(PipModel);
			injector.mapSingleton(SourcesModel);
			
			// Controllers
			commandMap.mapEvent(OrxEvent.STARTUP, StartupCommand, OrxEvent);
			commandMap.mapEvent(OrxEvent.INITALIZE, InitializeCommand, OrxEvent);
			
			commandMap.mapEvent(LoadWorkAreaEvent.LOAD_WORK_AREA, LoadWorkAreaCommand, LoadWorkAreaEvent);
			commandMap.mapEvent(LoadDisplayAreaEvent.LOAD_DISPLAY_AREA, LoadDisplayAreaCommand, LoadDisplayAreaEvent);
			commandMap.mapEvent(LoadPipAreaEvent.LOAD_PIP_AREA, LoadPipAreaCommand, LoadPipAreaEvent);
			commandMap.mapEvent(LoadPipEvent.LOAD_PIP, LoadPipCommand, LoadPipEvent);
			
			commandMap.mapEvent(CreatePipAreaEvent.CREATE_PIP_AREA, CreatePipAreaCommand, CreatePipAreaEvent);
			commandMap.mapEvent(CreatePipEvent.CREATE_PIP, CreatePipCommand, CreatePipEvent);
			
			//Views
			mediatorMap.mapView(Main, MainMediator);
			mediatorMap.mapView(EditionView, EditionMediator);
			
			mediatorMap.mapView(ScreenView, ScreenMediator);
			mediatorMap.mapView(PipAreaView, PipAreaMediator);
			mediatorMap.mapView(PipView, PipMediator);
		}
	}
}