package aw.orx.controllers.commands
{
   	import aw.orx.controllers.events.LoadWorkAreaEvent;
   	import aw.orx.models.services.ILoaderService;
   	import aw.orx.models.services.IOrxService;
   	import aw.orx.models.services.LoaderService;
   	import aw.orx.models.services.XMLLoaderService;
   	import aw.orx.models.vo.XmlUrlVO;
   	
   	import org.robotlegs.mvcs.Command;
    
    public class InitializeCommand extends Command
    {
		[Inject]
		public var xmlLoaderService:XMLLoaderService;
		
		[Inject]
		public var _loaderService:IOrxService;
				
		override public function execute() : void
		{
			if(_loaderService is LoaderService) {
				collectUrls(_loaderService as LoaderService);
			}
		}
		
		public function collectUrls(loaderService:LoaderService):void
		{
			var filesUrlsTab:Array = ["menus", "sections"];
			
			for (var i:int=0; i<filesUrlsTab.length; i++) 
			{
				var list:XMLList = xmlLoaderService.getXMLList(filesUrlsTab[i]) as XMLList;
				var listArr:Vector.<XmlUrlVO>;
				for each (var item:Object in list) 
				{ 
					listArr.push(item as XmlUrlVO);
				}
				loaderService.loaderObject[filesUrlsTab[i]+"Urls"] = listArr;
			}
			
			run();
		}
		
		private function collectDatas():void
		{
			
		}
		
		protected function run():void
		{
			dispatch(new LoadWorkAreaEvent(LoadWorkAreaEvent.LOAD_WORK_AREA));
		}
    }
}