package aw.orx.models
{
	import aw.orx.controllers.events.CreatePipEvent;
	import aw.orx.models.events.PipModelEvent;
	import aw.orx.models.vo.PipVO;
	
	import org.robotlegs.mvcs.Actor;
	
	public class PipModel extends Actor
	{
		private var _pipAreaScale:Number;
		private var _depthValue:uint;
		private var _labelNeeded:Boolean = true;
		private var _pipInfos:Vector.<PipVO> = new Vector.<PipVO>;
		private var _repereAlphaMin:Number = 0.75;
		private var _repereW:Number = 10;
		private var _reperesNeeded:Array = [false, false, true, false];
		
		//-----------------//
		// GETTERS-SETTERS //
		

		public function get depthValue():uint
		{
			return _depthValue;
		}
		public function set depthValue(value:uint):void
		{
			_depthValue = value;
		}

		public function get labelNeeded():Boolean
		{
			return _labelNeeded;
		}
		public function set labelNeeded(value:Boolean):void
		{
			_labelNeeded = value;
		}

		public function get pipAreaScale():Number 
		{ 
			return _pipAreaScale; 
		}
		public function set pipAreaScale(value:Number):void 
		{ 
			_pipAreaScale = value; 
		}
		
		
		public function get reperesNeeded():Array
		{
			return _reperesNeeded;
		}
		public function get repereW():Number
		{
			return _repereW;
		}

		public function get repereAlphaMin():Number
		{
			return _repereAlphaMin;
		}

		public function get pipInfos():Vector.<PipVO> 
		{ 
			return _pipInfos; 
		}
		
		//-----------------//
		
		public function updateCollection(collection:Vector.<PipVO>):void
		{
			_pipInfos.splice(0, _pipInfos.length);
			
			for each (var site:Object in collection)
			{
				_pipInfos.push(site as PipVO);
			} 
			
			dispatch(new PipModelEvent(PipModelEvent.COLLECTION, collection as Array));
		}
	}
}