package aw.orx.models.services
{
	import aw.orx.models.*;
	import aw.orx.models.events.PipModelEvent;
	import aw.orx.models.events.WorkAreaModelEvent;
	
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;

	public class LoaderOrxService extends LoaderService implements IOrxService
	{
		[Inject] public var inputsModel:SourcesModel;
		[Inject] public var framesModel:SourcesModel;
		[Inject] public var logosModel:SourcesModel;
		
		[Inject] public var menuHModel:MenuHModel;
		
		[Inject] public var workAreaModel:WorkAreaModel;
		[Inject] public var displayAreaModel:DisplayAreaModel;
		[Inject] public var pipAreaModel:PipAreaModel;		
		//[Inject] public var screenModel:ScreenModel;
		//[Inject] public var settingsModel:SettingsModel;
		[Inject] public var pipModel:PipModel;
		
		public function LoaderOrxService()
		{
			super();
			loaderObject.getInputs.addEventListener(ResultEvent.RESULT, getInputs_resultHandler);
			loaderObject.getFrames.addEventListener(ResultEvent.RESULT, getFrames_resultHandler);
			loaderObject.getLogos.addEventListener(ResultEvent.RESULT, getLogos_resultHandler);
			
			loaderObject.getMenuUrls.addEventListener(ResultEvent.RESULT, getMenuUrls_resultHandler);
			loaderObject.getWorkAreas.addEventListener(ResultEvent.RESULT, getWorkAreas_resultHandler);
			loaderObject.getDisplayAreas.addEventListener(ResultEvent.RESULT, getDisplayAreas_resultHandler);			
			loaderObject.getPipAreas.addEventListener(ResultEvent.RESULT, getPipAreas_resultHandler);
			loaderObject.getScreens.addEventListener(ResultEvent.RESULT, getScreens_resultHandler);
			loaderObject.getSettings.addEventListener(ResultEvent.RESULT, getSettings_resultHandler);
			loaderObject.getPips.addEventListener(ResultEvent.RESULT, getPips_resultHandler);
			
			loaderObject.createPipArea.addEventListener(ResultEvent.RESULT, createPipArea_resultHandler);
			loaderObject.createSettings.addEventListener(ResultEvent.RESULT, createSettings_resultHandler);
			loaderObject.createPip.addEventListener(ResultEvent.RESULT, createPip_resultHandler);
			
			loaderObject.addEventListener(FaultEvent.FAULT, faultHandler);
		}
		
		
		public function getInputs():void
		{
			loaderObject.getInputs();
		}
		public function getFrames():void
		{
			loaderObject.getFrames();
		}
		public function getLogos():void
		{
			loaderObject.getLogos();
		}
		
		public function getMenuUrls():void
		{
			loaderObject.getMenuUrls();
		}
		public function getWorkAreas():void
		{
			loaderObject.getWorkAreas();
		}
		public function getDisplayAreas():void
		{
			loaderObject.getDisplayAreas();
		}
		public function getPipAreas():void
		{
			loaderObject.getPipAreas();
		}
		public function getScreens():void
		{
			loaderObject.getScreens();
		}
		public function getPips(screen:uint, pipArea:String):void
		{
			loaderObject.getPips(screen, pipArea);
		}
		public function getSettings(pipId:uint, pipArea:String):void
		{
			loaderObject.getSettings(pipId, pipArea);
		}
		public function createWorkAreas():void
		{
			
		}
		public function createPipArea(name:String, pipsTab:Array):void
		{
			loaderObject.createPipArea(name, pipsTab);
		}
		public function createPip():void
		{
			loaderObject.createPip();
		}
		public function createSettings():void
		{
			loaderObject.createSettings();
		}
		
		
		/*
		* Handlers
		*/
		
		protected function getInputs_resultHandler(event:ResultEvent):void
		{
			inputsModel.updateCollection(event.result as Array);
		}
		protected function getFrames_resultHandler(event:ResultEvent):void
		{
			framesModel.updateCollection(event.result as Array);
		}
		protected function getLogos_resultHandler(event:ResultEvent):void
		{
			logosModel.updateCollection(event.result as Array);
		}
		
		protected function getMenuUrls_resultHandler(event:ResultEvent):void
		{
			menuHModel.updateCollection(event.result as Array);
		}
		protected function getWorkAreas_resultHandler(event:ResultEvent):void
		{
			workAreaModel.updateCollection(event.result as Array);
		}
		protected function getDisplayAreas_resultHandler(event:ResultEvent):void
		{
			displayAreaModel.updateCollection(event.result as Array);
		}
		protected function getPipAreas_resultHandler(event:ResultEvent):void
		{
			pipAreaModel.updateCollection(event.result as Array);
		}
		
		protected function getScreens_resultHandler(event:ResultEvent):void
		{
			//screenModel.updateCollection(event.result as Array);
		}
		protected function getSettings_resultHandler(event:ResultEvent):void
		{
			//settingsModel.updateCollection(event.result as Array);
		}
		protected function getPips_resultHandler(event:ResultEvent):void
		{
			//pipModel.updateCollection(event.result as Array);
		}
		
		
		protected function createWorkArea_resultHandler(event:ResultEvent):void
		{
			dispatch(new WorkAreaModelEvent(WorkAreaModelEvent.CREATED));
		}
		protected function createPipArea_resultHandler(event:ResultEvent):void
		{
			//dispatch(new PipAreaModelEvent(PipAreaModelEvent.SITE_CREATED));
		}
		protected function createSettings_resultHandler(event:ResultEvent):void
		{
			//dispatch(new SettingsEvent(SettingsEvent.SITE_CREATED));
		}
		protected function createPip_resultHandler(event:ResultEvent):void
		{
			dispatch(new PipModelEvent(PipModelEvent.CREATED));
		}
		
		
		protected function faultHandler(event:FaultEvent):void
		{
			trace(event.toString());
		}
	}
}