package aw.orx.views.mediators.workArea.displayArea.edition.screen
{
	import aw.orx.controllers.events.CreatePipEvent;
	import aw.orx.controllers.events.LoadPipAreaEvent;
	import aw.orx.controllers.events.LoadPipEvent;
	import aw.orx.models.PipAreaModel;
	import aw.orx.models.PipModel;
	import aw.orx.models.vo.PipVO;
	import aw.orx.views.components.workArea.displayArea.edition.screen.PipAreaView;
	import aw.orx.views.components.workArea.displayArea.edition.screen.pipArea.DepthSelector;
	import aw.orx.views.components.workArea.displayArea.edition.screen.pipArea.pip.PipView;
	import aw.orx.views.events.PipAreaEvent;
	import aw.orx.views.events.PipEvent;
	import aw.orx.views.mediators.workArea.displayArea.edition.screen.pipArea.pip.PipMediator;
	
	import org.robotlegs.mvcs.Mediator;
	
	import spark.primitives.Line;

	public class PipAreaMediator extends Mediator
	{
		
		[Inject] public var view:PipAreaView;
		[Inject] public var model:PipAreaModel;
		[Inject] public var pipAreaTitre:String;
		
		private var _pipLoadedNum:uint = 0;
		
		override public function onRegister():void
		{
			//_view
			pipAreaTitre = model.titre;
			for (var i:int=0; i<model.pipsTab.length; i++) 
			{
				createPip(model.pipsTab[i]);
			}
			//eventMap.mapListener(PipAreaView, PipEvent.PIP_LOADED, pipLoaded);
			//eventMap.mapListener(DepthSelector, PipEvent.PIP_CHANGE_DEPTH, pipDepthChanged);
			
			//eventDispatcher
			eventMap.mapListener(eventDispatcher, CreatePipEvent.CREATE_PIP, updateArea);
		}
		
		private function createPip(infos:Vector.<PipVO>):void
		{
			var pipModel:PipModel = new PipModel;
			pipModel.updateCollection(infos);
			
			var pipView:PipView = new PipView;
			view.pipsGroup.addChild(pipView);
			
			var mediator:PipMediator = new PipMediator;
			mediator.model = pipModel;
			mediator.view = pipView;
			//mediator.pipId = infos.id;
			
			eventMap.mapListener(pipView, PipEvent.PIP_LOADED, pipLoaded);
			
		}
		private function pipLoaded(e:PipEvent):void
		{
			trace("pipLoaded");
			
			if(_pipLoadedNum<model.pipsTab.length) {
				_pipLoadedNum++;
			} else {
				trace("_pipLoadedNum:"+_pipLoadedNum);
				dispatch(new LoadPipAreaEvent(LoadPipAreaEvent.LOAD_PIP_AREA, pipAreaTitre));
			}
		}
		/*private function pipDepthChanged():void
		{
			trace("pipDepthChanged");
			
			dispatch(new PipEvent(PipEvent.PIP_AREA_UPDATED));
		}*/
		
		protected function updateArea(e:CreatePipEvent):void
		{
			trace("updateArea");
			// titre
			view.titre.text = model.titre;
			
			// pip
			updatePip(e.pipInfos);
			
			// guides
			updateGuides();
			
			// depthSelector
			updateDepths();
		}
		
		private function updatePip(infos:Vector.<PipVO>):void
		{
			dispatch(new PipAreaEvent(PipAreaEvent.PIP_AREA_UPDATED, infos));
		}
		private function updateGuides():void
		{
			view.guides.mouseEnabled = false;
			for (var i:int=0; i<view.guides.numElements; i++) 
			{
				var guide:Line = view.guides.getElementAt(i) as Line;
				guide.xFrom =	0;
				guide.xTo = 	0;
				guide.yFrom =	0;
				guide.yTo = 	0;
			}
		}
		private function updateDepths():void
		{
			for (var i:int=0; i<view.depthSelector.numElements; i++) 
			{
				var pip:PipView = view.depthSelector.getElementAt(i) as PipView;
				view.depthSelector.setElementIndex(pip, view.depthSelector.numElements-1);
			}
		}
	}
}