package aw.orx.views.mediators.workArea.displayArea.edition.screen.pipArea.pip
{
	import aw.orx.controllers.events.CreatePipEvent;
	import aw.orx.models.PipModel;
	import aw.orx.models.vo.PipVO;
	import aw.orx.views.components.workArea.displayArea.edition.screen.pipArea.pip.PipView;
	import aw.orx.views.events.PipEvent;
	
	import flash.events.MouseEvent;
	import flash.filters.DropShadowFilter;
	
	import mx.containers.Canvas;
	import mx.containers.Form;
	
	import org.robotlegs.mvcs.Mediator;
	
	import spark.primitives.Rect;
	
	public class PipMediator extends Mediator
	{
		[Inject] public var view:PipView;
		[Inject] public var model:PipModel;
		
		[Inject] public var pipId:String;
		
		override public function onRegister():void
		{
			//_view
			for (var i:int = 0; i<view.numElements; i++) 
			{
				if(view.getElementAt(i) is Rect) {
					var item:Rect = view.getElementAt(i) as Rect;
					if(item.id.indexOf("r_")>0) {
						eventMap.mapListener(item, MouseEvent.MOUSE_OVER, repereMouseOver);
						eventMap.mapListener(item, MouseEvent.MOUSE_OUT, repereMouseOut);
						eventMap.mapListener(item, MouseEvent.MOUSE_DOWN, repereMouseDown);
						eventMap.mapListener(item, MouseEvent.MOUSE_UP, repereMouseUp);
					}
				}
			}
			
			//eventDispatcher
			eventMap.mapListener(eventDispatcher, CreatePipEvent.CREATE_PIP, updatePip);
		}
		
		protected function updatePip(e:CreatePipEvent):void
		{
			var infos:PipVO = model.pipInfos as PipVO;
			pipId = 				infos.id;
			
			// component
			view.id = 				pipId;
			view.x =				Math.floor(infos.x/model.pipAreaScale);
			view.y = 				Math.floor(infos.y/model.pipAreaScale);
			view.width = 			Math.floor(infos.w/model.pipAreaScale);
			view.height = 			Math.floor(infos.h/model.pipAreaScale);
						
			// background
			view.bkg.x=					0; 
			view.bkg.y=					0;
			view.bkg.width=				infos.w;
			view.bkg.height=				infos.h;
			view.bkg.radiusX=			infos.radius;
			view.bkg.radiusY=			infos.radius;
			//_view.bkg.backgroundColor=		infos.color;
			//_view.bkg.dropShadowVisible=	infos.shadow; 
			//_view.bkg.borderVisible=		false;
			//_view.bkg.styleName=			"carre";
			if(infos.shadow) {
				view.bkg.filters=			[new DropShadowFilter(infos.shadowDistance, infos.shadowAngle)];
			} else {
				view.border.filters=		[];
			}
			
			
			// mask (cropLayer)
			view.cropLayer.x=					infos.crop_x;
			view.cropLayer.y=					infos.crop_y; 
			view.cropLayer.width=				infos.crop_w;
			view.cropLayer.height=				infos.crop_h;
			//_view.cropLayer.backgroundAlpha=	0;
			//_view.cropLayer.backgroundColor=	0x000000;
			
			// image
			//_view.img.x=			(_view.width-_view.img.width)/2;
			//_view.img.y=			(_view.height-_view.img.height)/2;
			view.img.width=		infos.imgW;
			view.img.height=		infos.imgH; 
			view.img.source=		infos.img ? infos.img:"images/default.jpg";
			
			// label
			view.lbl.width=		100;
			view.lbl.height=		20;
			view.lbl.x=			model.labelNeeded ? (view.width-view.lbl.width)/2:0;
			view.lbl.y=			model.labelNeeded ? (view.height-view.lbl.height)/2:0;
			view.lbl.styleName=	"nom";
			view.lbl.visible=		model.labelNeeded;
			view.lbl.text=			infos.label;
			
			// border
			view.border.radiusX=				infos.borderRadius;
			view.border.radiusY=				infos.borderRadius;
			view.border.alpha=					infos.border_alpha;
			view.borderColor.color=			infos.borderColor;
			view.border.stroke.weight=			infos.borderWeight;
			//_view.border.backgroundAlpha=		0;
			//_view.border.dropShadowVisible=		infos.borderShadow; 
			//_view.border.borderVisible=			true;
			//_view.border.styleName=				"carreBorder"; 
			if(infos.borderShadow) {
				view.border.filters=			[new DropShadowFilter(infos.borderShadowDistance, infos.borderShadowAngle)];
			} else {
				view.border.filters=			[];
			}
			
			// alphalayer
			view.alphaLayer.width = 	view.width;
			view.alphaLayer.height = 	view.height;
			
			// reperes
			for (var i:int = 0; i<view.numElements; i++) 
			{
				if(view.getElementAt(i) is Rect) {
					var item:Rect = view.getElementAt(i) as Rect;
					if(item.id.indexOf("r_")>0) {
						item.width = 		model.repereW;
						item.height = 		model.repereW;
						//item.styleName = 	"layerRepere";
						item.alpha =		model.repereAlphaMin;
						item.visible = 		model.reperesNeeded[i];
					}
				}
			}
			view.r_tr.x = 			view.r_br.x;
			view.r_br.x = 			view.width-model.repereW;
			view.r_br.y = 			view.height-model.repereW;
			view.r_bl.y = 			view.r_br.y;
					
			view.alpha =		 	infos.alpha/100;
			/*_view.sizeRatio =		infos.sizeRatio;
			_view.cropRatio =		infos.cropRatio;*/
			
			
			dispatch(new PipEvent(PipEvent.PIP_UPDATED, pipId));
		}
		
		private function repereMouseOver(e:MouseEvent):void
		{
			var target:Canvas = Canvas(e.currentTarget);
			target.alpha = 1;
		}
		private function repereMouseOut(e:MouseEvent):void
		{
			var target:Canvas = Canvas(e.currentTarget);
			target.alpha = model.repereAlphaMin;
		}
		private function repereMouseDown(e:MouseEvent):void
		{
			var evt:PipEvent = new PipEvent(PipEvent.PIP_REPERE_DOWN, pipId);
			var lockedRepere:Canvas = Canvas(e.currentTarget);
			evt.repereId = lockedRepere.id;
			dispatch(evt);
		}
		private function repereMouseUp(e:MouseEvent):void
		{
			var evt:PipEvent = new PipEvent(PipEvent.PIP_REPERE_UP, pipId);								
			dispatch(evt);
		}
	}
}